/*
 Name:		SpotWelder.ino
 Created:	7/11/2017 11:38:26 AM
 Author:	Wojciech Domski
*/

#include "SevSeg\SevSeg.h"

SevSeg sevseg; //Instantiate a seven segment controller object
int change;
int number = 1;

#define SW_TRIGGER		3
#define SW_CHANGE		4
#define OUT_POWER		5

int sw_change_state;
int sw_tigger_state;

// the setup function runs once when you press reset or power the board
void setup() {
	byte numDigits = 1;
	byte digitPins[] = {2}; //Digits: 1,2,3,4 <--put one resistor (ex: 220 Ohms, or 330 Ohms, etc, on each digit pin)
	byte segmentPins[] = { 6, 7, 8, 9, 10, 11, 12, 13 }; //Segments: A,B,C,D,E,F,G,Period

	sevseg.begin(COMMON_ANODE, numDigits, digitPins, segmentPins);
	sevseg.setBrightness(10);
	
	pinMode(SW_TRIGGER, INPUT);
	digitalWrite(SW_TRIGGER, HIGH);
	pinMode(SW_CHANGE, INPUT);
	digitalWrite(SW_CHANGE, HIGH);

	pinMode(OUT_POWER, OUTPUT);
	digitalWrite(OUT_POWER, LOW);

}

// the loop function runs over and over again until power down or reset
void loop() {
	int digit, comma;

	if (change > 10000)
	{
		++number;
		if (number > 9)
			number = 0;
		change = 0;
	}

	if (digitalRead(SW_CHANGE) == 0 && sw_change_state == 0)
	{
		delay(40);
		if (digitalRead(SW_CHANGE) == 0 && sw_change_state == 0)
		{
			number++;
			if (number > 19)
				number = 1;
			sw_change_state = 1;
		}
	}
	if (digitalRead(SW_CHANGE) == 1 && sw_change_state == 1)
		sw_change_state = 0;

	if (number >= 0 && number < 10)
	{
		digit = number;
		comma = 1;
	}
	else {
		digit = number - 10;
		comma = 0;
	}
	sevseg.setNumber(digit, comma);
	sevseg.refreshDisplay(); // Must run repeatedly; don't use blocking code (ex: delay()) in the loop() function or this won't work right

	if (digitalRead(SW_TRIGGER) == 0 && sw_tigger_state == 0)
	{
		delay(40);
		if (digitalRead(SW_TRIGGER) == 0 && sw_tigger_state == 0)
		{
			digitalWrite(OUT_POWER, HIGH);
			delay(number * 10);
			digitalWrite(OUT_POWER, LOW);
			sw_tigger_state = 1;
		}
	}
	if (digitalRead(SW_TRIGGER) == 1 && sw_tigger_state == 1)
		sw_tigger_state = 0;
}
